#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 2e5+9;

int n,q;
vector <int> g[N],sta[N];
int col[N];
int br[N];
int sz[N],tin[N],tout[N],gore[N],clk = 1;
int koji[N];
int drvo[4*N],lazyadd[4*N],lazyset[4*N];
int boja[4*N],lazyboja[4*N];
int parent[N];

void nadji(int x,int par){
    int sum = 0,isti = 0;
    parent[x] = par;
    for(auto f : sta[x]){
        if(f == par) continue;
        nadji(f,x);
        if(col[f] == col[x]) isti++;
        sum += br[f];
    }
    br[x] = sum - (isti-1);
}

void dfs(int x,int par){
    sz[x] = 1;
    for(int i = 0; i < g[x].size(); i++){
        int f = g[x][i];
        if(f == par) continue;
        dfs(f,x);
        sz[x] += sz[f];
        if(sz[f] > sz[g[x][0]]){
            swap(g[x][i],g[x][0]);
        }
    }
}

void dfshld(int x,int par){
    koji[clk] = x;
    tin[x] = clk++;
    for(auto f : g[x]){
        if(f == par) continue;
        if(2*sz[f] >= sz[x]){ /// tesko dete - ili prvi ili ne postoji
            gore[f] = gore[x];
        }
        else{
            gore[f] = f;
        }
        dfshld(f,x);
    }
    tout[x] = clk;
}

void build(int i,int j,int node){
    if(i == j){
        drvo[node] = br[koji[i]];
        boja[node] = col[koji[i]];
        return;
    }
    int mid = i+(j-i)/2;
    build(i,mid,2*node);
    build(mid+1,j,2*node+1);
}

void pushboja(int i,int j,int node){
    if(lazyboja[node]){
        boja[node] = lazyboja[node];
        if(i != j){
            lazyboja[2*node] = lazyboja[node];
            lazyboja[2*node+1] = lazyboja[node];
        }
        lazyboja[node] = 0;
    }
}

void updateboja(int i,int j,int l,int r,int val,int node){
    pushboja(i,j,node);
    if(j < l || i > r) return;
    if(l <= i && r >= j){
        lazyboja[node] = val;
        pushboja(i,j,node);
        return;
    }
    int mid = i+(j-i)/2;
    updateboja(i,mid,l,r,val,2*node);
    updateboja(mid+1,j,l,r,val,2*node+1);
}

int dajboju(int pos){
    int l = 1,r = n,node = 1;
    while(l < r){
        pushboja(l,r,node);
        int mid = l+(r-l)/2;
        if(pos <= mid){
            node *= 2;
            r = mid;
        }
        else{
            node *= 2;
            node++;
            l = mid+1;
        }
    }
    pushboja(l,r,node);
    return boja[node];
}

/*int dajboju(int i,int j,int l,int r,int node){
    pushboja(i,j,node);
    if(j < l || i > r) return 0;
    if(l <= i && r >= j){
        return boja[node];
    }
    int mid = i+(j-i)/2;
    return max(dajboju(i,mid,l,r,2*node),dajboju(mid+1,j,l,r,2*node+1));
}*/

void pushset(int i,int j,int node){
    if(lazyset[node]){
        drvo[node] = lazyset[node];
        if(i != j){
            lazyset[2*node] = lazyset[node];
            lazyadd[2*node] = 0;
            lazyset[2*node+1] = lazyset[node];
            lazyadd[2*node+1] = 0;
        }
        lazyset[node] = 0;
    }
}

void pushadd(int i,int j,int node){
    if(lazyadd[node]){
        drvo[node] += lazyadd[node];
        if(i != j){
            lazyadd[2*node] += lazyadd[node];
            lazyadd[2*node+1] += lazyadd[node];
        }
        lazyadd[node] = 0;
    }
}

void updateset(int i,int j,int l,int r,int val,int node){
    pushset(i,j,node);
    pushadd(i,j,node);
    if(j < l || i > r){
        return;
    }
    if(l <= i && r >= j){
        lazyset[node] = val;
        pushset(i,j,node);
        return;
    }
    int mid = i+(j-i)/2;
    updateset(i,mid,l,r,val,2*node);
    updateset(mid+1,j,l,r,val,2*node+1);
}

void updateadd(int i,int j,int l,int r,int val,int node){
    pushset(i,j,node);
    pushadd(i,j,node);
    if(j < l || i > r){
        return;
    }
    if(l <= i && r >= j){
        lazyadd[node] += val;
        pushadd(i,j,node);
        return;
    }
    int mid = i+(j-i)/2;
    updateadd(i,mid,l,r,val,2*node);
    updateadd(mid+1,j,l,r,val,2*node+1);
}

int get(int pos){
    int l = 1,r = n,node = 1;
    while(l < r){
        pushset(l,r,node);
        pushadd(l,r,node);
        int mid = l+(r-l)/2;
        if(pos <= mid){
            node *= 2;
            r = mid;
        }
        else{
            node *= 2;
            node++;
            l = mid+1;
        }
    }
    pushset(l,r,node);
    pushadd(l,r,node);
    return drvo[node];
}

/*int get(int i,int j,int l,int r,int node){
    pushset(i,j,node);
    pushadd(i,j,node);
    if(j < l || i > r) return 0;
    if(l <= i && r >= j){
        return drvo[node];
    }
    int mid = i+(j-i)/2;
    return max(get(i,mid,l,r,2*node),get(mid+1,j,l,r,2*node+1));
}*/

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    for(int i = 1; i < n; i++){
        int u,v;
        cin >> u >> v;
        sta[u].push_back(v);
        sta[v].push_back(u);
    }
    for(int i = 1; i <= n; i++){
        cin >> col[i];
    }

    nadji(1,0); /// PROVERI!!!

    for(int i = 1; i <= n; i++){
        for(auto f : sta[i]){
            if(f != parent[i]) g[i].push_back(f);
        }
    }

    dfs(1,0);
    dfshld(1,0);

    build(1,n,1);

    while(q--){
        int u,c;
        cin >> u >> c;
        int brc = get(tin[u]);
        /// stavi sve u subtriju na 1
        updateset(1,n,tin[u],tout[u]-1,1,1);

        if(u == 1){
            cout << "1\n";
            updateboja(1,n,tin[u],tout[u]-1,c,1);
            continue;
        }

        int ovaj = dajboju(tin[u]);
        int par = dajboju(tin[parent[u]]);

        int dod = 0;
        if(ovaj == par){ /// svima od parent[u] do 1 dodas -(brc-1) jer jedna komp prezivi
            if(c == par){ /// ne nastaje nijedna nova pa -brc+1
                dod = -brc+1;
            }
            else{ /// nastaje jedna nova pa -brc+2
                dod = -brc+2;
            }
        }
        else{ /// svima od parent[u] dodas -brc jer sve crknu
            if(c == par){ /// ne nastaje nijedna nova pa -brc
                dod = -brc;
            }
            else{ /// nastaje jedna nova pa -brc+1
                dod = -brc+1;
            }
        }

        /// dodaj dod svima od parent[u] do 1
        int nd = parent[u];
        while(nd){
            int dokle = gore[nd];
            updateadd(1,n,tin[dokle],tin[nd],dod,1);
            nd = gore[nd];
            nd = parent[nd];
        }

        updateboja(1,n,tin[u],tout[u]-1,c,1);
        cout << get(tin[1]) << "\n";
    }
}