#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<double> vd;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<pi> vp;
typedef vector<pl> vpl;

const int maxn = 2e5+5;
const int K = 445;
int n, q;
vi e[maxn], a, p(maxn);
vp t;

void root(int x){
    for (auto& i : e[x]){
        if (i != p[x]){
            p[i] = x;
            root(i);
        }
    }
}

void dfs_prvi(int x, int c){
    a[x] = c;

    for (auto& i : e[x]){
        if (p[x] != i)
            dfs_prvi(i, c);
    }
}

vi vis_prvi;
void calc_prvi(int x, int st){
    vis_prvi[x] = 1;
    for (auto& i : e[x]){
        if (a[i] == a[x] && st != i){
            calc_prvi(i,x);
        }
    }
}

void prvi_subtask(){

    root(1);

    for (pi p : t){
        int x = p.first, c = p.second, sol = 0;

        dfs_prvi(x, c);
        vis_prvi = vi(n+1,0);
        for (int i = 1; i <= n; ++i)
            if (!vis_prvi[i]){
                calc_prvi(i, i);
                ++sol;
            }
        cout << sol << '\n';
    }
    exit(0);
}

int cur = 0;
vi din(maxn), dout(maxn);
void dfs(int x){
    din[x] = cur++;

    for (auto& i : e[x]){
        if (i != p[x])
            dfs(i);
    }

    dout[x] = cur;
}

//da li je u dete od v
bool f(int u, int v){
    if (din[v] <= din[u] && dout[v] >= dout[u])
        return 1;
    return 0;
}

vi dp(maxn);
void init(int ind){

    for (int i = 1; i <= n; ++i){
        for (int j = ind-1; j>-1; --j){
            if (f(i, t[j].first)){
                a[i] = t[j].second;
                break;
            }
        }
    }

    queue<int> st;

    vi cnt(n+1,0);
    for (int i = 2; i <= n; ++i){
        int len = e[i].size();
        if (len == 1){
            dp[i] = 1;
            ++cnt[p[i]];

            int ln = e[p[i]].size();
            if (cnt[p[i]] == ln-1 && p[i] != 1){
                st.push(p[i]);
                continue;
            }

            if (cnt[p[i]] == ln && p[i] == 1)
                st.push(1);
        }
    }

    while(!st.empty()){
        int x = st.front();
        st.pop();

        int k = 0;
        dp[x] = 1;
        for (auto& i : e[x]){
            if (i == p[x]) continue;
            if (a[i] == a[x]) ++k;
            dp[x] += dp[i]; 
        }

        dp[x] -= k;

        int len = e[p[x]].size();
        ++cnt[p[x]];

        if (cnt[p[x]] == len-1 && p[x] != 1){
            st.push(p[x]);
            continue;
        }

        if (x == 1) break;
        if (cnt[p[x]] == len && p[x] == 1)
            st.push(1);
    }
}

vi dom(maxn), pokr(maxn), dif(maxn);
void dominiraj(int last, int ind){
    for (int i = ind-1; i >= last; --i){
        if (f(t[i].first, t[ind].first))
            dom[i] = 1;
    }
}
int res;
int neodeven(int x, int c, int last, int ind){
    int sol = res;

    for (int i = last; i < ind; ++i){
        if (dom[i] || !f(t[i].first, x)) continue;

        sol -= dif[i];
    }

    sol -= dp[x];
    ++sol;

    if (a[x] == a[p[x]] && a[x] == c)
        return sol;
    if (a[x] == a[p[x]] && a[x] != c){
        ++sol;
        return sol;
    }
    if (a[x] != a[p[x]] && a[p[x]] != c)
        return sol;
    if (a[x] != a[p[x]] && a[p[x]] == c){
        --sol;
        return sol;
    }
}

int solve(int x, int c, int last, int ind){

    int k = -1, col = -1;
    for (int i = ind-1; i >= last; --i){
        if (f(x, t[i].first) && t[i].first != x){
            k = t[i].first;
            col = t[i].second;
            break;
        }
    }

    if (k == -1){
        int sol = neodeven(x,c,last,ind);
        dominiraj(last,ind);
        dif[ind] = sol-res;
        return sol;
    }
    pokr[ind] = col;

    int sol = res;
    for (int i = last; i < ind; ++i){
        if (dom[i] || !f(t[i].first, x) || t[i].first == x) continue;

        if (t[i].second != c){
            --sol;
            --dif[ind];
        }
    }

    if (col != c){
        ++sol;
        ++dif[ind];
    }

    dominiraj(last, ind);
    return sol;
}

int main()
{
    ios_base::sync_with_stdio(false); 
    cin.tie(nullptr); 
    cout.tie(nullptr); 
    cerr.tie(nullptr);    

    cin >> n >> q;

    bool prvi = (n <= 1000 && q <= 1000);

    for (int i = 1; i < n; ++i){
        int u, v;
        cin >> u >> v;

        e[u].push_back(v);
        e[v].push_back(u);
    }

    a = vi(n+1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];

    t = vp(q);
    for (auto& i : t){
        cin >> i.first >> i.second;
    }

    if (n == 1){
        for (int i = 0; i < q; ++i)
            cout << "1\n";
        return 0;
    }

    //if (prvi)
      //  prvi_subtask();

    //rokaj sad kad znas

    root(1);

    dfs(1);

    int last = 0;
    for (int h = 0; h < q; ++h){
        if (h%K==0){
            init(h);
            last = h;
        }

        if (h == 0)
            res = dp[1];

        res = solve(t[h].first, t[h].second, last, h);
        cout << res << '\n';
    }
}