#include <bits/stdc++.h>
#define maxn 200010
using namespace std;

int n, q, ans;
int col[maxn], pr[maxn], h[maxn], b[maxn], c[maxn], iT[maxn], oT[maxn], vert[maxn], gT;
vector<vector<int> > gr;
bool was[maxn];

void dfs(int x, int p, int cur){
	iT[x] = gT;
	vert[iT[x]]=x;
	++gT;
	h[x] = cur;
	pr[x]=p;
	for(auto i : gr[x]){
		if(i == p){
			continue;
		}
		dfs(i, x, cur+1);
	}
	oT[x] = gT;
	++gT;
}

void dfs1(int x, int p, int& minX){
	if(h[x] < h[minX]){
		minX = x;
	}
	was[x] = 1;
	for(auto i : gr[x]){
		if(p ==i or b[i] != b[x]){
			continue;
		}
		dfs1(i, x, minX);
	}
}

int segTree[8*maxn], lazy[8*maxn];

void prop(int idx){
	if(!lazy[idx]){
		return;
	}
	segTree[idx] = 0;
	lazy[idx] = 0;
	if(idx*2+2 < 8*maxn){
		lazy[idx*2+1] = 1;
		lazy[idx*2+2] = 1;
	}
}

void init(int idx, int l, int r){
	if(l == r){
		segTree[idx] = c[l];
		return;
	}
	int mid = (l+r)/2;
	init(idx*2+1, l, mid);
	init(idx*2+2, mid+1, r);
	segTree[idx] = segTree[idx*2+1] + segTree[idx*2+2];
}

int getS(int idx, int l, int r, int ql, int qr){
	prop(idx);
	if(l >= ql and r <= qr){
		return segTree[idx];
	}
	if(r < ql or l > qr){
		return 0;
	}
	int mid = (l+r)/2;
	int res = getS(idx*2+1, l, mid, ql, qr) + getS(idx*2+2, mid+1, r, ql, qr);
	segTree[idx] = segTree[idx*2+1] + segTree[idx*2+2];
	return res;
}

void rUpd(int idx, int l, int r, int ql, int qr){
	prop(idx);
	if(l >=ql and r <= qr){
		lazy[idx] = 1;
		prop(idx);
		return;
	}
	if(r < ql or l > qr){
		return;
	}
	int mid = (l+r)/2;
	rUpd(idx*2+1, l, mid, ql, qr);
	rUpd(idx*2+2, mid+1, r, ql, qr);
	segTree[idx] = segTree[idx*2+1] + segTree[idx*2+2];
}

void upd(int idx, int l, int r, int x, int val){
	//cerr << lazy[idx] << ' ';
	prop(idx);
	//cerr << segTree[idx] << ' ';
	if(l == r){
		segTree[idx] = val;
		return;
	}
	int mid = (l+r)/2;
	if(x <= mid){
		upd(idx*2+1, l, mid, x, val);
	} else {
		upd(idx*2+2, mid+1, r, x, val);
	}
	prop(idx*2+1);
	prop(idx*2+2);
	segTree[idx] = segTree[idx*2+1] + segTree[idx*2+2];
}

int segTree1[8*maxn], lazy1[8*maxn];

void prop1(int idx){
	if(!lazy1[idx]){
		return;
	}
	segTree1[idx] = lazy1[idx];
	if(idx*2+2 < 4*maxn){
		lazy1[idx*2+1] = max(lazy1[idx*2+1], lazy1[idx]);
		lazy1[idx*2+2] = max(lazy1[2*idx+2], lazy1[idx]);
	}
	lazy1[idx] = 0;
}

void init1(int idx, int l, int r){
	if(l == r){
		segTree1[idx] = -1;
		return;
	}
	int mid = (l+r)/2;
	init1(idx*2+1, l, mid);
	init1(idx*2+2, mid+1, r);
	segTree1[idx] = -1;
}

int getS1(int idx, int l, int r, int ql, int qr){
	prop1(idx);
	if(l >= ql and r <= qr){
		return segTree1[idx];
	}
	if(r < ql or l > qr){
		return 0;
	}
	int mid = (l+r)/2;
	int res = max(getS1(idx*2+1, l, mid, ql, qr),getS1(idx*2+2, mid+1, r, ql, qr));
	segTree1[idx] = max(segTree1[idx*2+1], segTree[idx*2+2]);
	return res;
}

int getC1(int idx, int l, int r, int x){
	prop1(idx);
	if(l == r){
		return segTree1[idx];
	}
	int mid = (l+r)/2;
	if(x <= mid){
		return getC1(idx*2+1, l, mid, x);
	}
	return getC1(idx*2+2, mid+1, r, x);
}

void rUpd1(int idx, int l, int r, int ql, int qr, int qI){
	prop1(idx);
	if(l >=ql and r <= qr){
		lazy1[idx] = qI;
		prop1(idx);
		return;
	}
	if(r < ql or l > qr){
		return;
	}
	int mid = (l+r)/2;
	rUpd1(idx*2+1, l, mid, ql, qr, qI);
	rUpd1(idx*2+2, mid+1, r, ql, qr, qI);
	segTree1[idx] = max(segTree1[idx*2+1],segTree1[idx*2+2]);
}

int main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	cin >> n >> q;
	gr.resize(n, vector<int>());
	for(int i = 1; i < n; ++i){
		int x,y;
		cin >> x >> y;
		--x, --y;
		gr[x].push_back(y);
		gr[y].push_back(x);
	}
	for(int i = 0; i < n; ++i){
		cin >> b[i];
	}
	dfs(0, -1, 0);
	for(int i = 0; i < n; ++i){
		if(!was[i]){
			int minV=i;
			dfs1(i, -1, minV);
			c[iT[minV]]= 1;
		}
	}
	init(0, 0, gT-1);
	init1(0, 0, gT-1);
	for(int i = 0; i < q; ++i){
		int u;
		cin >> u >> col[i];
		--u;
		rUpd(0, 0, gT-1, iT[u], oT[u]);
		if(pr[u] >= 0){
			int qI = getC1(0, 0, gT-1, iT[pr[u]]);
			//cerr << qI << '\n';
			if(qI >= 0 and col[qI] != col[i]){
				upd(0, 0, gT-1, iT[u], 1);
			} else if(qI == -1 and b[pr[u]] != col[i]){
				upd(0, 0, gT-1, iT[u], 1);
			}

		} else {
			upd(0, 0, gT-1, iT[u], 1);
		}
		
        rUpd1(0, 0, gT-1, iT[u], oT[u], i);
		cout << getS(0, 0, gT-1, 0, gT-1) << '\n';
	}
}
/*6 4
1 2
1 3
2 4
2 5
3 6
1 2 1 1 3 3
4 3
4 2
1 1
2 2*/