#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<int,ll> pii;
const int maxn = 200005;
const int inf = 1e9 + 5;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

int n, q;
int boja[maxn];

template<int size, int lg>
struct hld {
  vector<int> edges[size];
  int bigchild[size];
  int sz[size];
  int depth[size];
  int chain[size];
  int label[size], label_time;
  int par[size];
  int lca_lift[size][lg];

  ll dp[size];

  int N;

    ll bor[4*maxn];
    pii lenj[4*maxn];
    void propagate(int v, int tl, int tr){
        if(lenj[v].se){
            bor[v] = lenj[v].fi * bor[v] + (tr - tl + 1) * lenj[v].se;
            if(tl != tr){
                if(!lenj[v].fi)lenj[2*v+1] = {0, 0};
                lenj[2*v+1].se += lenj[v].se;
                if (!lenj[v].fi)lenj[2*v+2] = {0, 0};
                lenj[2*v+2].se += lenj[v].se;
            }
        }
        lenj[v] = {1, 0};
    }
    void lazyupd(int v, int tl, int tr, int l, int r, pii vre){
        propagate(v, tl, tr);
        if(tl > tr || tl > r || tr < l)return;
        if(tl >= l && tr <= r) {
            bor[v] = vre.fi * bor[v] + (tr - tl + 1) * vre.se;
            if (tl != tr) {
                if(!vre.fi)lenj[2*v+1] = {0, 0};
                lenj[2*v+1].se += vre.se;
                if (!vre.fi)lenj[2*v+2] = {0, 0};
                lenj[2*v+2].se += vre.se;
            }
            return;
        }
        int mid = (tl + tr) / 2;
        lazyupd(v*2+1,tl,mid,l,r,vre);
        lazyupd(v*2+2,mid+1,tr,l,r,vre);
        bor[v] = bor[v * 2 + 1] + bor[v * 2 + 2];
    }
    ll kveri(int v, int tl, int tr, int l, int r){
        propagate(v, tl, tr);
        if(tl > r || l > tr)return 0;
        if(l <= tl && r >= tr)return bor[v];
        int mid = (tl + tr)/2;
        return kveri(v*2+1,tl,mid,l,r) + kveri(v*2+2,mid+1,tr,l,r);
    }
    void lazyupd(int l, int r, pii vre){
        lazyupd(0, 0, n - 1, l, r, vre);
    }
    ll kveri(int l, int r){
        return kveri(0, 0, n - 1, l, r);
    }
  /* ----------- init phase 1 ----------- */
  /* initialize segtree, clear edges, etc. */

  /* ----------- init phase 2 ----------- */
  /* put edges in */

  void add_edge(int u, int v) {
    edges[u].push_back(v);
    edges[v].push_back(u);
  }

  /* ----------- init phase 3 ----------- */

    // (v) - broj razlicitih komponenti u subtree od v
    void dfs1(int v, int p){
        for(auto u : edges[v]){
            if(u != p){
                dfs1(u, v);
                dp[v] += dp[u] + (boja[u] != boja[v]);
            }
        }
    }

  /* build the lca and hld stuff */
  void init_tree(int root = 0) {
    for(int i = 0; i < N; i++)chain[i] = i;
    // dp
    dfs1(root, -1);
    // lca
    lca_dfs(root, -1);

    // size, compute biggest children
    dfs_size(root, -1, 0);

    // compute chains
    dfs_chains(root, -1);

    // label nodes
    label_time = 0;
    dfs_labels(root, -1);
  }

  void lca_dfs(int v, int par) {
    lca_lift[v][0] = par;

    for (int i = 1; i < lg; i++) {
      if (lca_lift[v][i - 1] == -1) lca_lift[v][i] = -1;
      else lca_lift[v][i] = lca_lift[lca_lift[v][i - 1]][i - 1];
    }

    for (int x: edges[v]) {
      if (x != par) {
        lca_dfs(x, v);
      }
    }
  }

  void dfs_size(int v, int p, int d) {
    sz[v] = 1;
    depth[v] = d;
    par[v] = p;
    int bigc = -1, bigv = -1;

    for (int x: edges[v]) {
      if (x != p) {
        dfs_size(x, v, d + 1);
        sz[v] += sz[x];
        if (sz[x] > bigv) {
          bigc = x;
          bigv = sz[x];
        }
      }
    }

    bigchild[v] = bigc;
  }

  void dfs_chains(int v, int p) {
    if (bigchild[v] != -1) {
      chain[bigchild[v]] = chain[v];
    }

    for (int x: edges[v]) {
      if (x != p) {
        dfs_chains(x, v);
      }
    }
  }

  void dfs_labels(int v, int p) {
    label[v] = label_time++;
    dp[v] += 1;
    lazyupd(label[v], label[v], {0, dp[v]});
    dp[v] -= 1;
    if (bigchild[v] != -1) {
      dfs_labels(bigchild[v], v);
    }

    for (int x: edges[v]) {
      if (x != p && x != bigchild[v]) {
        dfs_labels(x, v);
      }
    }
  }

  /* ----------- init phase 4 ----------- */
  /* usage */

  int lca(int a, int b) {
    if (depth[a] < depth[b]) swap(a, b);
    int d = depth[a] - depth[b];
    int v = get_kth_ancestor(a, d);
    if (v == b) {
      return v;
    } else {
      for (int i = lg - 1; i >= 0; i--) {
        if (lca_lift[v][i] != lca_lift[b][i]) {
          v = lca_lift[v][i];
          b = lca_lift[b][i];
        }
      }
      return lca_lift[b][0];
    }
  }

  int get_kth_ancestor(int v, int k) {
    for (int i = lg - 1; i >= 0; i--) {
	    if (v == -1) return v;
      if ((1 << i) <= k) {
        v = lca_lift[v][i];
        k -= (1 << i);
      }
    }
    return v;
  }

  /* excludes p */
  int query_chain(int v, int p) {
    int val = 0;
    while (depth[p] < depth[v]) {
      int top = chain[v];
      if (depth[top] <= depth[p]) {
        int diff = depth[v] - depth[p];
        top = get_kth_ancestor(v, diff - 1);
      }
      val += kveri(label[top], label[v]);
      v = par[top];
    }
    return val;
  }

  int query(int u, int v) {
    int lc = lca(u, v);
    int val = query_chain(u, lc) + query_chain(v, lc);
    return val + kveri(label[lc], label[lc]);
  }

  /* excludes p */
  void update_chain(int v, int p, pii val) {
    while (depth[p] < depth[v]) {
      int top = chain[v];
      if (depth[top] <= depth[p]) {
        int diff = depth[v] - depth[p];
        top = get_kth_ancestor(v, diff - 1);
      }
      lazyupd(label[top], label[v], val);
      v = par[top];
    }
  }

  void update(int u, int v, pii val) {
    int lc = lca(u, v);
    update_chain(u, lc, val);
    update_chain(v, lc, val);
    lazyupd(label[lc], label[lc], val);
  }
};

hld<maxn,20> h;

void print(){
    ff(i,0,n - 1){
        cout << h.kveri(i, i) << " ";
    }
    cout << endl;
    cout << endl;
}

ll bor[4*maxn];
ll lenj[4*maxn];
void propagate(int v, int tl, int tr){
    if(lenj[v]){
        bor[v] = lenj[v];
        if (tl != tr) {
            lenj[v * 2 + 1] = lenj[v];
            lenj[v * 2 + 2] = lenj[v];
        }
        lenj[v] = 0;
    }
}
void lazyupd(int v, int tl, int tr, int l, int r, ll vre){
    propagate(v, tl, tr);
    if(tl > tr | tl > r || tr < l)return;
    if(tl >= l && tr <= r) {
        bor[v] = vre;
        if (tl != tr) {
            lenj[v * 2 + 1] = vre;
            lenj[v * 2 + 2] = vre;
        }
        return;
    }
    int mid = (tl + tr) / 2;
    lazyupd(v*2+1,tl,mid,l,r,vre);
    lazyupd(v*2+2,mid+1,tr,l,r,vre);
    bor[v] = bor[v * 2 + 1] + bor[v * 2 + 2];
}
ll kveri(int v, int tl, int tr, int l, int r){
    propagate(v, tl, tr);
    if(tl > r || l > tr)return 0;
    if(l <= tl && r >= tr)return bor[v];
    int mid = (tl + tr)/2;
    return kveri(v*2+1,tl,mid,l,r) + kveri(v*2+2,mid+1,tr,l,r);
}

int main()
{
    ios::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    cin >> n >> q;
    ff(i,1,n - 1){
        int u, v;
        cin >> u >> v;
        u--, v--;
        h.add_edge(u, v);
    }
    ff(i,0,n - 1)cin >> boja[i];
    h.init_tree();
    ff(i,0,n - 1)lazyupd(0,0,n - 1,h.label[i],h.label[i],boja[i]);
    while(q--){
        int v, c;
        cin >> v >> c;
        v--;
        int in = h.label[v];
        ll kol = h.kveri(in, in);
        int out = in + h.sz[v] - 1;
        h.update(0, v, {1, -kol});
        kol = 1;
        h.update(0, v, {1, kol});
        if(h.par[v] != -1){
            int trboja = kveri(0,0,n - 1, in, in);
            int parboja = kveri(0,0,n - 1, h.label[h.par[v]], h.label[h.par[v]]);
            if(parboja != trboja){
                if(parboja == c)h.update(0, h.par[v], {1, (ll)-1});
            }
            else{
                if(parboja != c){
                    h.update(0, h.par[v], {1, (ll)1});
                }
            }
        }
        boja[v] = c;
        h.lazyupd(in, out, {0, 1});
        lazyupd(0,0,n - 1, in, out, (ll)c);
        cout << h.kveri(0, 0) << endl;
    }
    return 0;
}
/**

9 4
1 2
2 4
2 5
1 3
3 7
3 6
6 8
6 9
1 2 3 4 5 6 7 8 9
6 3
7 3
8 9
6 9


6 4
1 2
1 3
2 4
2 5
3 6
1 2 1 1 3 3
4 3
4 2
1 1
2 2

// probati bojenje sahovski ili slicno

**/